% Clear the workspace, the command window, and close all figures.
clear;
clc;
close all;

% profile on;

% Define the file path for the data file to be loaded.
dir = './DataMergingPerEvent_414_long.mat';

% Load the data file.
load(dir);
%% Compute PDRF values for each event.

% Initialize variables to store the results of each event.
num_events = 18;
PDRF = cell(1, num_events);
PDRF_event = cell(1, num_events);
PR_event = cell(1, num_events);
PR_conti = cell(1, num_events);
PDRF_average = zeros(1, num_events);
PR_event_average = zeros(1, num_events);
ElapsedTime = [];
% Loop over each event.
E = {E1, E2, E3, E4, E5, E6, E7, E8, E9, ...
    E10, E11, E12, E13, E14, E15, E16, E17, E18}; % Store events in a cell array
% tic
% Define model parameters
sig_x = 2.01;
sig_y = 0.02;
    % Prediction Horizon
T1 = 0.5;
T2 = 1;
T3 = 2;
T4 = 3;
for nn = 1
    
    % Extract the x, y, vx, vy, ax, and ay components of the ego and object vehicles.
    event = E{nn}; % Access the event data

    x_s = event.x_s;
    y_s = event.y_s;
    vx_s = event.vx_s;
    vy_s = event.vy_s;
    ax_s = event.ax_s;
    ay_s = event.ay_s;
    
    x_n = event.x_n;
    y_n = event.y_n;
    vx_n = event.vx_n;
    vy_n = event.vy_n;
    ax_n = event.ax_n;
    ay_n = event.ay_n;
    
    len = length(x_s);
    
    x= linspace(0, 30, len);  % Example x data
    y = zeros(len);  % Initialize y data

    for i = 1:len
        [PROB05, reachbleN, predictedS, cPO] = C_PROB(x_s(i), y_s(i), vx_s(i), vy_s(i), x_n(i), y_n(i), vx_n(i), vy_n(i), ax_n(i), ay_n(i), T1, sig_x, sig_y);
        subplot(4,2,1);
        plot(reachbleN)
%         xlim([0 300]);
        xlim([min(predictedS.Vertices(:,1))-10,max(predictedS.Vertices(:,1))+90]);
        ylim([-15 0]);
        hold on
        plot(predictedS)
        hold on
        plot(cPO)
        hold off
        pause(0.01);
        if i==len
            hold on;
        end

        
            
        
        
        
        subplot(4,2,3)
        [PROB1, reachbleN, predictedS, cPO] = C_PROB(x_s(i), y_s(i), vx_s(i), vy_s(i), x_n(i), y_n(i), vx_n(i), vy_n(i), ax_n(i), ay_n(i), T2, sig_x, sig_y);
        plot(reachbleN)
%         xlim([0 300]);
        xlim([min(predictedS.Vertices(:,1))-10,max(predictedS.Vertices(:,1))+90]);
        ylim([-15 0]);
        hold on
        plot(predictedS)
        hold on
        plot(cPO)
        hold off
        pause(0.01);
        if i==len
            hold on;
        end
        
        subplot(4,2,5)
        [PROB2, reachbleN, predictedS, cPO, p_ax(i),p_ay(i)] = C_PROB(x_s(i), y_s(i), vx_s(i), vy_s(i), x_n(i), y_n(i), vx_n(i), vy_n(i), ax_n(i), ay_n(i), T3, sig_x, sig_y);
        plot(reachbleN)
%         xlim([0 300]);
        xlim([min(predictedS.Vertices(:,1))-10,max(predictedS.Vertices(:,1))+90]);
        ylim([-20 10]);
        hold on
        plot(predictedS)
        hold on
        plot(cPO)
        hold off
        pause(0.01);
        if i==len
            hold on;
        end
 % this is for p_ax plot               
%         subplot(8,2,10)
%         plot(i,p_ax,'*');hold on
        
        
        
        
        
        subplot(4,2,7)
        [PROB3, reachbleN, predictedS, cPO] = C_PROB(x_s(i), y_s(i), vx_s(i), vy_s(i), x_n(i), y_n(i), vx_n(i), 0, ax_n(i), ay_n(i), T4, sig_x, sig_y);
        plot(reachbleN)
%         xlim([0 300]);
        xlim([min(predictedS.Vertices(:,1))-10,max(predictedS.Vertices(:,1))+90]);
        ylim([-25 15]);
        hold on
        plot(predictedS)
        hold on
        plot(cPO)
        hold off
        pause(0.01);
        if i==len
            hold on;
        end
%         if pdrf(i,1)> 0  && (flagtime_PDRF==0)%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%        flagtime_PDRF= i*0.1; % detect the time when danger was flagged by PDRF 
%         end 
%         [PROB1,reachbleN,predictedS] = C_PROB(x_s(i), y_s(i), vx_s(i), vy_s(i), x_n(i), y_n(i), vx_n(i), vy_n(i), ax_n(i), ay_n(i), T2, sig_x, sig_y);% the collision probability
%         
%         [PROB2,reachbleN,predictedS] = C_PROB(x_s(i), y_s(i), vx_s(i), vy_s(i), x_n(i), y_n(i), vx_n(i), vy_n(i), ax_n(i), ay_n(i), T3, sig_x, sig_y);
%         
%         [PROB3,reachbleN,predictedS] = C_PROB(x_s(i), y_s(i), vx_s(i), vy_s(i), x_n(i), y_n(i), vx_n(i), vy_n(i), ax_n(i), ay_n(i), T4, sig_x, sig_y);
        
%         PDRF_storage(i)=0.5*1439.3*(2590/(2590+1439.3)).^2*((vx_s(i)-vx_n(i)).^2+(vy_s(i)-vy_n(i)).^2)*PROB(i);

    end

end
