function d_dot = d_dot_cal(s_x, s_vx, s_y, s_vy, n_x, n_vx, n_y, n_vy)
    % Input: position and velocity values of subject (s) and neighboring (n) vehicles
    % Output: the dot product of the distance vectors (d_dot)

    % Define positions of subject and neighboring vehicles
    pi = [s_x; s_y];
    pj = [n_x; n_y];

    % Define velocities of subject and neighboring vehicles
    vi = [s_vx; s_vy];
    vj = [n_vx; n_vy];

    % Calculate the distance between the subject and the neighboring vehicle
    d = sqrt((pi - pj)' * (pi - pj));

    % Compute the dot product of the distance vectors (d_dot)
    d_dot = (1 / d) * (pi - pj)' * (vi - vj);
end


% function [TTC,ord,d,d_dot,d_dot_dot]=TTC_cal(s_x,s_vx,s_ax,s_y,s_vy,s_ay,n_x,n_vx,n_ax,n_y,n_vy,n_ay)
% pi=[s_x;s_y];
% pj=[n_x;n_y];
% 
% vi=[s_vx;s_vy];
% vj=[n_vx;n_vy];
% 
% ai=[s_ax;s_ay];
% aj=[n_ax;n_ay];
% 
% d=sqrt((pi-pj)'*(pi-pj));
% d_dot=(1/d)*(pi-pj)'*(vi-vj);
% d_dot_dot=(1/d).*((vi-vj)'*(vi-vj)-d_dot^2);%+(pi-pj)'*(ai-aj)
% % d_x=s_x-n_x;
% % d_y=s_y-n_y;
% % d_vec=[d_x;d_y];
% % 
% % d_vx=s_vx-n_vx;
% % d_vy=s_vy-n_vy;
% % dv_vec=[d_vx;d_vy];
% % 
% % d_ax=s_ax-n_ax;
% % d_ay=s_ay-n_ay;
% % da_vec=[d_ax;d_ay];
% % 
% % 
% % d=sqrt(d_vec'*d_vec);
% % d_dot=(1/d)*d_vec'*dv_vec;
% % d_dot_dot=(1/d)*(dv_vec'*dv_vec-d_dot.^2);
% 
% if abs(d_dot_dot)<0.01 % d_dot_dot=0; The first order TTC. 
%     if d_dot==0% velocity=0, TTC=inf
%         TTC=99;
%         ord=10;
%     else
%        TTC=-d/d_dot; % v~=0,TTC=d/v
%        ord=20;
%     end   
% else % d_dot_dot~=0 The second order TTC
%     delta=d_dot.^2-2*d_dot_dot*d;
%     if delta<0 % no collision, the nearest point time. In this case, set TTC=99
% %        TTC=d_dot/d_dot_dot; 
%         TTC=99;
%         ord=30;
%     else % delta>0
%        if min([(-d_dot+sqrt(delta))/d_dot_dot,(-d_dot-sqrt(delta))/d_dot_dot])>=0
%           TTC=min([(-d_dot+sqrt(delta))/d_dot_dot,(-d_dot-sqrt(delta))/d_dot_dot]);
%           ord=40;
%        else
%           TTC=max([(-d_dot+sqrt(delta))/d_dot_dot,(-d_dot-sqrt(delta))/d_dot_dot]);
%           ord=50;
%        end
%     end  
% end
% if abs(TTC)>99
%     TTC=99;
% end
% if TTC<0
%    TTC=99;
% end
% %% looming gated
% % [th1,th2,th3,th4]=loom_det(s_x,s_vx,s_y,s_vy,n_x,n_vx,n_y,n_vy);
% % looming_prod=max([th1,th2,th3,th4]).*min([th1,th2,th3,th4]);
% % TTC(looming_prod>0)=99;
% end