% function [PROB,reachbleN,predictedS,cPO] = C_PROB_open_improved(S_x, S_y, S_vx, S_vy, N_x, N_y, N_vx, N_vy, Singlestep,miu_x,sig_x,miu_y,sig_y)
%  [PROB,reachbleN,predictedS,cPO] = C_PROB_open_improved(S_x, S_y, S_vx, S_vy, N_x, N_y, N_vx, N_vy, Singlestep,miu_x,sig_x,miu_y,sig_y)
function PROB = C_PROB_open_improved(S_x, S_y, S_vx, S_vy, N_x, N_y, N_vx, N_vy, n_ax,n_ay,Singlestep,sig_x,sig_y)
% function PROB= C_PROB_open_improved(S_x, S_y, S_vx, S_vy, N_x, N_y, N_vx, N_vy, Singlestep,meanx,sigx)
% function PROB = C_PROB_open_improved(S_x, S_y, S_vx, S_vy, N_x, N_y,N_vx, N_vy, Singlestep,x1)% only one parameter
max_long_acc = 8;
max_lat_acc = 5;
max_brake_acc = 8; %vehicle behaviour constraints;

[NX, NY] = reachable(N_x, N_y, N_vx, N_vy, Singlestep, max_long_acc, max_brake_acc, max_lat_acc); %neighbour vehicle
[RX, RY] = reachable(S_x, S_y, S_vx, S_vy, Singlestep, 0, 0, 0); %subject vehicle
L = 4; % length of vehicle
W = 2; % width of vehicle
RS_Xlimit = [RX(1) - L, RX(1) + L];
RS_Ylimit = [RY(1) + W, RY(1) - W];
SX = RS_Xlimit([1, 1, 2, 2]);
SY = RS_Ylimit([1, 2, 2, 1]);
reachbleN = polyshape(NX, NY);
predictedS = polyshape(SX, SY);
cPO = intersect(reachbleN, predictedS);
% C_ax_max = ((max(cPO.Vertices(:, 1)) - N_x) - N_vx * Singlestep) * (2 / (Singlestep^2));
% C_ax_min = ((min(cPO.Vertices(:, 1)) - N_x) - N_vx * Singlestep) * (2 / (Singlestep^2));
length = size(cPO.Vertices, 1);

C_ay = zeros(length, 1);
C_ax = zeros(length, 1);
% for i = 1:length %(collisionPolygon.Vertices)
%     C_ay(i, 1) = ((cPO.Vertices(i, 2) - N_y) - N_vy * Singlestep) * (2 / (Singlestep^2));
%     C_ax(i, 1) = ((cPO.Vertices(i, 1) - N_x) - N_vx * Singlestep) * (2 / (Singlestep^2));
% end
C_ay(:, 1) = ((cPO.Vertices(:, 2) - N_y) - N_vy * Singlestep) * (2 / (Singlestep^2));
C_ax(:, 1) = ((cPO.Vertices(:, 1) - N_x) - N_vx * Singlestep)* (2 / (Singlestep^2));
%finding the integral bound points A1, A2, A3 and A4: A3 and A4 are
%necessary for the pentagon and hexagon
%%
% fun = @(x, y) normpdf(x, 0, 0.7) .* normpdf(y, 0, 0.2);
% z=intpoly(fun,C_ax,C_ay)
PROB=0;
xy_temp = [C_ax,C_ay];

F=@(x,y) normpdf(x, 0,sig_x) .* normpdf(y, 0, sig_y); % used for calibration

for i=1:length-2
    xy=[xy_temp(1,:);xy_temp(i+1,:);xy_temp(i+2,:)];
    I = TriIntegral(F, xy(:,1), xy(:,2));
    PROB=PROB+I;
%     [V,W]=simplexquad(3,xy);
%     PROB=PROB+W'*F(V(:,1),V(:,2));
end
end
%end